; SketchyLISP Extension Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; count

; ---conformance---
; SketchyLISP Extension

; ---purpose---
; Recursively count the atoms of a list.
; Members of all sublists are included.

; ---args---
; X - list

; ---keywords---
; COUNT function, list, member, size

; ---see-also---
; depth, length

; ---example---
; (count '(a b (c (d) e) ((f)))) => 6

; (require "nullp.scm") ; null?
; (require "plus.scm") ; +

; ---code---
(define (count x)
  (cond ((null? x) 0)
    ((pair? x)
      (+ (count (car x))
         (count (cdr x))))
    (else 1)))
