; SketchyLISP Extension Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; explode

; ---conformance---
; SketchyLISP Extension

; ---purpose---
; Explode a symbol into a list of symbols.

; ---args---
; X - symbol

; ---keywords---
; EXPLODE function, symbol, decomposition

; ---see-also---
; implode

; ---example---
; (explode 'hello) => (h e l l o)

; (require "lib/string.scm")
; (require "lib/map.scm")

; ---code---
(define (explode x)
  (map (lambda (x)
         (string->symbol (string x)))
       (string->list (symbol->string x))))
