; SketchyLISP Extension Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; implode

; ---conformance---
; SketchyLISP Extension

; ---purpose---
; Implode a list of symbols into a symbol.

; ---args---
; X - list of single-character symbols

; ---keywords---
; IMPLODE function, symbol, composition

; ---see-also---
; explode

; ---example---
; (implode '(h e l l o)) => hello

; (require "lib/not.scm")
; (require "lib/equal.scm") ; =
; (require "lib/s-length.scm") ; string-length
; (require "lib/s-ref.scm") ; string-ref
; (require "lib/map.scm")

; ---code---
(define (implode x)
  (letrec
    ((sym->char
       (lambda (x)
         (let ((str (symbol->string x)))
           (cond ((not (= (string-length str) 1))
               (bottom '(bad symbol in implode)))
             (else (string-ref str 0)))))))
    (string->symbol
      (list->string (map sym->char x)))))
