; SketchyLISP Extension Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; read-line

; ---conformance---
; SketchyLISP Extension

; ---purpose---
; Read a newline-terminated sequence of characters.
; Return a string containing the characters read.

; ---args---

; ---keywords---
; READ-LINE
; read, line, newline, string

; ---example---
; (read-line) hello world => " hello world "

; (require "lib/string.scm")
; (require "lib/reverse.scm")

; ---code---
(define (read-line)
  (letrec
    ((collect-chars
       (lambda (c s)
         (cond ((or (eof-object? c) (char=? c #\newline))
             (apply string (reverse s)))
           (else (collect-chars (read-char) (cons c s))))))
     (first-char
       (read-char)))
    (cond ((eof-object? first-char) first-char)
      (else (collect-chars first-char '())))))
