; SketchyLISP Extension Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; remv

; ---conformance---
; R5.91RS

; ---purpose---
; Remove atoms from lists.

; ---args---
; X - atom to remove
; A - list

; ---keywords---
; REMV function, lists, sets, set theory, member, remove

; ---see-also---
; remq, remv, memv, eqv?

; ---example---
; (remv 3 '(1 2 3 1 2 3)) => (1 2 1 2)

(define remv #t)

; (require "nullp.scm") ; null?
; (require "lib/eqvp.scm") ; eqv?
; (require "lib/not.scm")
(require "filter.scm")

; ---model---
; (define (remv x a)
;   (cond ((null? a) '())
;     ((eqv? x (car a)) (cdr a))
;     (else (cons (car a) (remove x (cdr a))))))

; ---code---
(define (remv x a)
  (filter (lambda (y)
            (not (eqv? x y)))
          a))
