; SketchyLISP Extension Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; replace

; ---conformance---
; SketchyLISP Extension

; ---purpose---
; Replace data in forms.
; Replace
; for each occurence of
; .V old
; in
; .V form
; with
; .V new.

; ---args---
; OLD - form to replace
; NEW - form to insert
; FORM - form to process

; ---keywords---
; REPLACE function, substitution, substitute, lists

; ---see-also---
; substitute

; ---example---
; (replace 'f 'g '(lambda (f x) (f x))) => (lambda (g x) (g x))

; (require "lib/equalp.scm") ; equal?

; ---code---
(define (replace old new form)
  (cond ((equal? form old) new)
    ((pair? form)
      (cons (replace old new (car form))
            (replace old new (cdr form))))
    (else form)))
