; SketchyLISP Library
; Copyright (C) 2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; map-car

; ---conformance---
; SketchyLISP Core

; ---purpose---
; Map a function over a list.

; ---args---
; F - function to apply
; A - list

; ---keywords---
; MAP-CAR function, mapping, lists, CAR

; ---see-also---
; map, member, list?

; ---example---
; :l lib/minus.scm -
; (map-car - '(1 2 3)) => (-1 -2 -3)

(define map-car #t)

; (require "nullp.scm") ; null?
(require "reverse.scm")

; ---code---
(define (map-car f a)
  (letrec
    ((mapc
       (lambda (a r)
         (cond ((null? a) (reverse r))
           (else (mapc (cdr a)
                       (cons (f (car a)) r)))))))
    (mapc a '())))
