; SketchyLISP Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; odd?

; ---conformance---
; R5RS

; ---purpose---
; Test whether a number is odd (not even).

; ---args---
; X - number

; ---keywords---
; ODD? function, odd, even, numbers, digit, predicate

; ---see-also---
; digits, even?, zero?

; ---example---
; (odd? 3) => #t

(define oddp #t)

(require "digits.scm")
(require "not.scm")
(require "reverse.scm")
(require "memq.scm")
; (require "evenp.scm") ; even?

; ---model---
; (define (odd? x)
;   (not (even? x)))

; ---code---
(define (odd? x)
  (and (memq (car (reverse (integer->list x)))
             (integer->list 13579))
       #t))
