; SketchyLISP Library
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; succ

; ---conformance---
; SketchyLISP Core

; ---purpose---
; Find the successor of a decimal digit.
; .B
; .C (succ 9d) => ().

; ---args---
; X - symbol representing a digit

; ---keywords---
; SUCC function, successor, numbers, digits

; ---see-also---
; digits, pred

; ---example---
; (succ 3d) => 4d

(require "digits.scm") ; 0d 1d 2d 3d 4d 5d 6d 7d 8d 9d

; ---code---
(define (succ x)
  (cond ((eq? x 0d) 1d)
        ((eq? x 1d) 2d)
        ((eq? x 2d) 3d)
        ((eq? x 3d) 4d)
        ((eq? x 4d) 5d)
        ((eq? x 5d) 6d)
        ((eq? x 6d) 7d)
        ((eq? x 7d) 8d)
        ((eq? x 8d) 9d)
        ((eq? x 9d) '())
        (else (bottom 'digit 'expected))))
