; SketchyLISP Example Program
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; bottles

; ---purpose---
; Print the lyrics of "99 bottles of beer on the wall".

; ---args---
; N - number of bottles

; ---language---
; R5RS Scheme

; ---keywords---
; BOTTLES, 99 bottles of beer, example programs

; ---example---
; (bottles 99) => #t

; (require "lib/minus.scm") ; -
; (require "lib/equal.scm") ; =
; (require "lib/zerop.scm") ; zero?
; (require "lib/newline.scm")

; ---code---
(define (bottles . n)
  (letrec
    ((bottles
       (lambda (n suffix)
         (begin
           (display n)
           (display (if (= n 1) " bottle" " bottles"))
           (display suffix)
           (newline))))
     (verse
       (lambda (n)
         (begin
           (bottles n " of beer on the wall,")
           (bottles n " of beer.")
           (display "Take one down and pass it around,")
           (newline)
           (bottles (- n 1) " of beer on the wall."))))
     (count-bottles
       (lambda (n)
         (or (zero? n)
             (begin (verse n)
                    (newline)
                    (count-bottles (- n 1)))))))
    (cond ((null? n)
        (count-bottles 99))
      (else (count-bottles (car n))))))
