; SketchyLISP Example Program
; Copyright (C) 2005,2006,2007 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; hanoi

; ---purpose---
; Solve the "Towers of Hanoi".

; ---language---
; R5RS Scheme

; ---args---
; N - number of disks

; ---keywords---
; HANOI function, Towers of Hanoi, example

; ---example---
; (hanoi 2) => ((from via) (from to) (via to))

; (require "lib/list.scm")
; (require "lib/append.scm")
; (require "lib/zerop.scm") ; zero?
; (require "lib/minus.scm") ; -

; ---code---
(define (hanoi n)
  (letrec
    ((_hanoi
       (lambda (from to via n)
         (cond ((zero? n) '())
           (else (append
                   (_hanoi from via to (- n 1))
                   (list (list from to))
                   (_hanoi via to from (- n 1))))))))
    (_hanoi 'from 'to 'via n)))
